const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const reports = sequelize.define(
    'reports',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

report_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"incorrect_location",


"wrong_info",


"duplicate",


"closed_permanently",


"inappropriate_content",


"other"

        ],

      },

details: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"open",


"in_review",


"resolved",


"rejected"

        ],

      },

reported_at: {
        type: DataTypes.DATE,
      
      

      },

resolved_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  reports.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















//end loop



    db.reports.belongsTo(db.places, {
      as: 'place',
      foreignKey: {
        name: 'placeId',
      },
      constraints: false,
    });

    db.reports.belongsTo(db.users, {
      as: 'reporter',
      foreignKey: {
        name: 'reporterId',
      },
      constraints: false,
    });




    db.reports.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.reports.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return reports;
};


